#include <stdio.h>
#include <stdlib.h>

typedef struct element *lista;

struct element {
	int x;
	lista next;
};

/* pomocna funkcija za duljinu liste */

int duljina(lista L) {
	int i=0;
	while(L) {
		L=L->next;
		i++;
	}
	return i;
}

/* pomocna funkcija koja dodaje novi broj na kraj liste */

void dodaj_na_kraj(lista *L, int x) {

	lista last,new;
	if (*L) {
		last=*L;
		while(last->next) last=last->next;
	}
	new=malloc(sizeof(struct element));
	new->x=x;
	if (*L) last=last->next=new;
	else (*L)=last=new;
	last->next=NULL;
}

/* (a) podzadatak, funkcija koja vraća lisni rez */

lista rez(lista L, int l, int d) {
	int i=0;
	lista M=NULL;

	/*umjesto "if (d<l) return NULL;" kao u zadatku, dodana je podrska za negativne indekse, kao npr. u Pythonu*/

	if (l<0) l=duljina(L)+l;
	if (d<0) d=duljina(L)+d;
	for(i=0;i<l;i++) 
		L=L->next;
	for(i=0;i<=d-l;i++) {
		dodaj_na_kraj(&M,L->x);
		L=L->next;
	}
	return M;
}

/* pomocna funkcija za ispis liste */

void ispisi(lista L) {
	for(;L;L=L->next) printf("%d ",L->x);
	printf("\n");
}

/* (b) podzadatak, funkcija koja vraća uniju lisnih rezova */

void unija(lista L, int n) {
	int i,l,d,dodaj;
	lista pom1,pom2,M=NULL;
	for(i=0;i<n;i++) {
		scanf("%d",&l);
		scanf("%d",&d);

		/* u O(n^2) vremena provjerimo što ide u uniju, a što je već tamo */

		for(pom1=rez(L,l,d);pom1;pom1=pom1->next) {
			dodaj=1;
			for(pom2=M;pom2;pom2=pom2->next)
				if(pom1->x==pom2->x) dodaj=0;
			if(dodaj) dodaj_na_kraj(&M,pom1->x);
		}
	}
	ispisi(M);
}

int main(void) {
	int n,x;
	lista L=NULL;
	scanf("%d",&n);
	for(int i=0;i<n;i++) {
		scanf("%d",&x);
		dodaj_na_kraj(&L,x);
	}

	/* isprobajmo glavne funkcije na nekim primjerima; oni bez negativnih indeksa su iz teksta zadatka */

	ispisi(rez(L,1,3));
	ispisi(rez(L,-1,-1));
	ispisi(rez(L,0,-1));
	unija(L,3);
	return 0;
}
