#include <stdio.h>
#include <stdlib.h>

typedef struct element *lista;

struct element {
	double x;
	lista next;
};

/* pomocna funkcija za duljinu liste */

int duljina(lista L) {
	int i=0;
	while(L) {
		L=L->next;
		i++;
	}
	return i;
}

/* pomocna funkcija koja dodaje novi broj na kraj liste */

void dodaj_na_kraj(lista *L, double x) {

	lista last,new;
	if (*L) {
		last=*L;
		while(last->next) last=last->next;
	}
	new=malloc(sizeof(struct element));
	new->x=x;
	if (*L) last=last->next=new;
	else (*L)=last=new;
	last->next=NULL;
}

/* (a) podzadatak, funkcija koja vraća lisni rez */

lista rez(lista L, int l, int d) {
	int i=0;
	lista M=NULL;

	/*umjesto "if (d<l) return NULL;" kao u zadatku, dodana je podrska za negativne indekse, kao npr. u Pythonu*/

	if (l<0) l=duljina(L)+l;
	if (d<0) d=duljina(L)+d;
	for(i=0;i<l;i++) 
		L=L->next;
	for(i=0;i<=d-l;i++) {
		dodaj_na_kraj(&M,L->x);
		L=L->next;
	}
	return M;
}

/* pomocna funkcija za ispis liste */

void ispisi(lista L) {
	for(;L;L=L->next) printf("%lf ",L->x);
	printf("\n");
}

/* (b) podzadatak, funkcija koja vraća presjek lisnih rezova */

void presjek(lista L, int n) {
	int i,l,d,dodaj,brisi;
	lista pom1,pom2,del,M=NULL;
	for(i=0;i<n;i++) {
		scanf("%d",&l);
		scanf("%d",&d);

		/* u O(n^2) dodajemo prvi rez (bez duplikata) u presjek, pa obrišemo što nije u ostalim rezovima */

		if (i==0) 
			for(pom1=rez(L,l,d);pom1;pom1=pom1->next) {
				dodaj=1;
				for(pom2=M;pom2;pom2=pom2->next) {
					if(pom1->x==pom2->x) dodaj=0;
				}
				if (dodaj) dodaj_na_kraj(&M,pom1->x);
		} else {
		for(pom1=M;pom1;) {
			brisi=1;
			for(pom2=rez(L,l,d);pom2;pom2=pom2->next) 
				if (pom1->x==pom2->x) brisi=0;
			if (brisi) {
				if (pom1==M) {	
					M=M->next;
					free(pom1);
					pom1=M;
				} else {
					for(pom2=M;pom2->next!=pom1;pom2=pom2->next);
					pom2->next=pom1->next;
					free(pom1);
				}
			} else pom1=pom1->next;
		}}}
	ispisi(M);
}

int main(void) {
	int n;
	double x;
	lista L=NULL;
	scanf("%d",&n);
	for(int i=0;i<n;i++) {
		scanf("%lf",&x);
		dodaj_na_kraj(&L,x);
	}

	/* isprobajmo glavne funkcije na nekim primjerima; oni bez negativnih indeksa su iz teksta zadatka */

	ispisi(rez(L,1,4));
	ispisi(rez(L,-1,-1));
	ispisi(rez(L,0,-1));
	presjek(L,2);
	return 0;
}
